/** ============================================================================
MIT License

Copyright (c) 2023 Institute for Automotive Engineering (ika), RWTH Aachen University

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
============================================================================= */

// --- Auto-generated by asn1ToConversionHeader.py -----------------------------

#pragma once

#include <etsi_its_denm_coding/ManagementContainer.h>
#include <etsi_its_denm_conversion/convertActionID.h>
#include <etsi_its_denm_conversion/convertTimestampIts.h>
#include <etsi_its_denm_conversion/convertTimestampIts.h>
#include <etsi_its_denm_conversion/convertTermination.h>
#include <etsi_its_denm_conversion/convertReferencePosition.h>
#include <etsi_its_denm_conversion/convertRelevanceDistance.h>
#include <etsi_its_denm_conversion/convertRelevanceTrafficDirection.h>
#include <etsi_its_denm_conversion/convertValidityDuration.h>
#include <etsi_its_denm_conversion/convertTransmissionInterval.h>
#include <etsi_its_denm_conversion/convertStationType.h>
#ifdef ROS1
#include <etsi_its_denm_msgs/ManagementContainer.h>
namespace denm_msgs = etsi_its_denm_msgs;
#else
#include <etsi_its_denm_msgs/msg/management_container.hpp>
namespace denm_msgs = etsi_its_denm_msgs::msg;
#endif


namespace etsi_its_denm_conversion {

void toRos_ManagementContainer(const ManagementContainer_t& in, denm_msgs::ManagementContainer& out) {

  toRos_ActionID(in.actionID, out.action_id);
  toRos_TimestampIts(in.detectionTime, out.detection_time);
  toRos_TimestampIts(in.referenceTime, out.reference_time);
  if (in.termination) {
    toRos_Termination(*in.termination, out.termination);
    out.termination_is_present = true;
  }

  toRos_ReferencePosition(in.eventPosition, out.event_position);
  if (in.relevanceDistance) {
    toRos_RelevanceDistance(*in.relevanceDistance, out.relevance_distance);
    out.relevance_distance_is_present = true;
  }

  if (in.relevanceTrafficDirection) {
    toRos_RelevanceTrafficDirection(*in.relevanceTrafficDirection, out.relevance_traffic_direction);
    out.relevance_traffic_direction_is_present = true;
  }

  if (in.validityDuration) {
    toRos_ValidityDuration(*in.validityDuration, out.validity_duration);
  }

  if (in.transmissionInterval) {
    toRos_TransmissionInterval(*in.transmissionInterval, out.transmission_interval);
    out.transmission_interval_is_present = true;
  }

  toRos_StationType(in.stationType, out.station_type);
}

void toStruct_ManagementContainer(const denm_msgs::ManagementContainer& in, ManagementContainer_t& out) {

  memset(&out, 0, sizeof(ManagementContainer_t));

  toStruct_ActionID(in.action_id, out.actionID);
  toStruct_TimestampIts(in.detection_time, out.detectionTime);
  toStruct_TimestampIts(in.reference_time, out.referenceTime);
  if (in.termination_is_present) {
    Termination_t termination;
    toStruct_Termination(in.termination, termination);
    out.termination = new Termination_t(termination);
  }

  toStruct_ReferencePosition(in.event_position, out.eventPosition);
  if (in.relevance_distance_is_present) {
    RelevanceDistance_t relevance_distance;
    toStruct_RelevanceDistance(in.relevance_distance, relevance_distance);
    out.relevanceDistance = new RelevanceDistance_t(relevance_distance);
  }

  if (in.relevance_traffic_direction_is_present) {
    RelevanceTrafficDirection_t relevance_traffic_direction;
    toStruct_RelevanceTrafficDirection(in.relevance_traffic_direction, relevance_traffic_direction);
    out.relevanceTrafficDirection = new RelevanceTrafficDirection_t(relevance_traffic_direction);
  }

  ValidityDuration_t validity_duration;
  toStruct_ValidityDuration(in.validity_duration, validity_duration);
  out.validityDuration = new ValidityDuration_t(validity_duration);

  if (in.transmission_interval_is_present) {
    TransmissionInterval_t transmission_interval;
    toStruct_TransmissionInterval(in.transmission_interval, transmission_interval);
    out.transmissionInterval = new TransmissionInterval_t(transmission_interval);
  }

  toStruct_StationType(in.station_type, out.stationType);
}

}